VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Synchronize Your Clock"
   ClientHeight    =   900
   ClientLeft      =   7425
   ClientTop       =   3900
   ClientWidth     =   3480
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   900
   ScaleWidth      =   3480
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdQuit 
      Caption         =   "&Quit"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   2520
      TabIndex        =   2
      Top             =   525
      Width           =   855
   End
   Begin VB.ComboBox cboURL 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   105
      TabIndex        =   0
      Text            =   "Combo1"
      Top             =   315
      Width           =   2325
   End
   Begin VB.CommandButton cmdSync 
      Caption         =   "&Synch"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   2520
      TabIndex        =   1
      Top             =   105
      Width           =   855
   End
   Begin MSWinsockLib.Winsock Winsock 
      Left            =   210
      Top             =   840
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Label Label1 
      Caption         =   "Server to Synchronize to:"
      Height          =   330
      Left            =   105
      TabIndex        =   3
      Top             =   105
      Width           =   2115
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim sNTP         As String  '32 bit time stamp returned by the server
Dim sngTimeDelay As Single  'time between the acknowledgement of
                            'the connection and the data received.
                            'we compensate by adding half of the round
                            'trip latency

Private Declare Function SetSystemTime Lib "kernel32" _
   (lpSystemTime As SYSTEMTIME) As Long
   
Private Type SYSTEMTIME
  wYear         As Integer
  wMonth        As Integer
  wDayOfWeek    As Integer
  wDay          As Integer
  wHour         As Integer
  wMinute       As Integer
  wSecond       As Integer
  wMilliseconds As Integer
End Type


Private Sub cmdQuit_Click()
    Unload Form1
End Sub

Private Sub cmdSync_Click()

    With Winsock
        .Close
        sNTP = Empty
        '
        ' Set the server's name.
        '
        .RemoteHost = cboURL.Text
        '
        ' Set the port.
        '
        .RemotePort = 37  'NTP server's port
        .Connect
    End With
    
End Sub
Private Sub Form_Load()
    '
    ' Populate the dropdown with various servers.
    '
    With cboURL
        .AddItem "ntp.cs.mu.oz.au"
        .AddItem "tock.usno.navy.mil"
        .AddItem "tick.usno.navy.mil"
        .AddItem "swisstime.ethz.ch"
        .AddItem "ntp-cup.external.hp.com"
        .AddItem "ntp1.fau.de"
        .AddItem "ntps1-0.cs.tu-berlin.de"
        .AddItem "time.ien.it"
        .AddItem "ntps1-1.rz.Uni-Osnabrueck.DE"
        .AddItem "tempo.cstv.to.cnr.it"
        .ListIndex = 0
    End With
End Sub

Private Sub WinSock_DataArrival(ByVal bytesTotal As Long)
Dim sData As String

    Call Winsock.GetData(sData, vbString)
    sNTP = sNTP & sData
End Sub
Private Sub WinSock_Connect()
    sngTimeDelay = Timer
End Sub
Private Sub WinSock_Close()
On Error Resume Next

Do Until Winsock.State = sckClosed
    Winsock.Close
    DoEvents
Loop

sngTimeDelay = ((Timer - sngTimeDelay) / 2)
Call SyncClock(sNTP)
End Sub
Private Sub SyncClock(sTemp As String)
Dim dblNTPTime      As Double
Dim UTCDATE         As Date
Dim LngTimeFrom1990 As Long
Dim ST              As SYSTEMTIME
     
sTemp = Trim$(sTemp)
If Len(sTemp) <> 4 Then
    Call MsgBox("NTP Server returned an invalid response.", _
                vbCritical, "Invalid Response")
    Exit Sub
End If

dblNTPTime = Asc(Left$(sTemp, 1)) * 256 ^ 3 + Asc(Mid$(sTemp, 2, 1)) * 256 ^ 2 + Asc(Mid$(sTemp, 3, 1)) * 256 ^ 1 + Asc(Right$(sTemp, 1))
      
LngTimeFrom1990 = dblNTPTime - 2840140800#

UTCDATE = DateAdd("s", CDbl(LngTimeFrom1990 + CLng(sngTimeDelay)), #1/1/1990#)

With ST
    .wYear = Year(UTCDATE)
    .wMonth = Month(UTCDATE)
    .wDay = Day(UTCDATE)
    .wHour = Hour(UTCDATE)
    .wMinute = Minute(UTCDATE)
    .wSecond = Second(UTCDATE)
End With

Call SetSystemTime(ST)
Call MsgBox("Clock synchronized succesfully.", vbInformation, "Update Successful")

End Sub
